#ifndef _OKC_HELPER_H_
#define _OKC_HELPER_H_

#include "okc_types.h"
#include <stdlib.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

void 
okc_print_coords (coords k);

void
okc_print_axis (lbr_axis l);

void
okc_subtract_coords (coords *difference, coords minuend, coords subtrahend);

void
okc_subtract_axis (lbr_axis *difference, lbr_axis minuend, lbr_axis subtrahend);

okc_handle_t*
okc_malloc_init_okc_handle_t (void);

okc_handle_t*
okc_destroy_okc_handle_t (okc_handle_t* okch);


void
okc_coords_set_all_zero (coords* k);


void
okc_axis_set_all_zero (lbr_axis* l);


void
okc_copy_axis (const lbr_axis src, lbr_axis* dest);


void
okc_copy_coords (const coords src, coords* dest);

#ifdef __cplusplus
}
#endif

#endif
